!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2005. All rights reserved.
!---------------------------------------------------------------------
                                                                 !=begin
!= Module dycore_type_mod
!
!   * Developers: Morikawa Yasuhiro
!   * Version: $Id: dycore_type.f90,v 1.1.1.1 2005/11/08 14:10:24 morikawa Exp $
!   * Tag Name: $Name: dcpam3-20060118 $
!   * Change History: 
!
!== Overview
!
!DCPAM Real, Integer, Character type.
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!== Future Plans
!
                                                                 !=end
module dycore_type_mod
                                                                 !=begin
  !== Dependency
  use type_mod     , only : REKIND, DBKIND, INTKIND, TOKEN, STRING, &
       &                    NMLARRAY
  use axis_type_mod, only : AXISINFO
                                                                 !=end
  implicit none
                                                                 !=begin
  !== Public Interface
  private
  public :: REKIND, DBKIND, INTKIND, TOKEN, STRING, NMLARRAY ! derived types
  public :: DYCORE_VARS, DYCORE_DIMS                         ! derived types
                                                                 !=end

!!$  !-------------------------------------------------------------------
!!$  !   ʻȿҤȤޤȤˤ
!!$  !-------------------------------------------------------------------
!!$  type DYCORE_GRIDS
!!$     integer(INTKIND)    :: im    ! ʻ(X)
!!$     integer(INTKIND)    :: jm    ! ʻ(Y)
!!$     integer(INTKIND)    :: km    ! ʻ(Z)
!!$     integer(INTKIND)    :: nm    ! ȿ
!!$  end type DYCORE_GRIDS

                                                                 !=begin
  !== Derived Types
  !
  !׻٤ʻǡҤȤޤȤˤ
  !3ץߥƥѤǡ
  !ᥤ롼ˤ   ʪ  ϳز  
  !ǡ
  !
  type DYCORE_VARS
     real(DBKIND), pointer     ::  &
          & xyz_VelLon(:,:,:)      , & ! ʻǡ(®ٷʬ)
          & xyz_VelLat(:,:,:)      , & ! ʻǡ(®ٰʬ)
          & xyz_Vor(:,:,:)       , & ! ʻǡ()
          & xyz_Div(:,:,:)       , & ! ʻǡ(ȯ)
          & xyz_Temp(:,:,:)      , & ! ʻǡ()
          & xyz_QVap(:,:,:)      , & ! ʻǡ(漾)

          & xy_Ps(:,:)           , & ! ʻǡ(ɽ̵)
          & xy_TempS(:,:)            ! ʻǡ(ɽ̲)

  end type DYCORE_VARS


  !
  !ǡҤȤޤȤˤ (ּϽ)
  !ٷٺɸ + ľҺɸ ǡ
  !ͥǡϤ졢Ϥνκݤ˽Ϥ졢
  !θ塢ʪϳزѤ롣
  !
  type DYCORE_DIMS
     type(AXISINFO)       ::   &
          & x_Lon            , & ! ʻɸ()
          & x_Lon_Weight     , & ! ʻɸ(ٽŤ)
          & y_Lat            , & ! ʻɸ()
          & y_Lat_Weight     , & ! ʻɸ(ٽŤ)
          & z_Sigma          , & ! ʻɸ(ҥ٥())
          & r_Sigma          ! ʻɸ(ҥ٥(Ⱦ))

  end type DYCORE_DIMS
                                                                 !=end

end module dycore_type_mod
